const CLASS_OPEN = 'qor-modal-open',
  ARIA_HIDDEN = 'aria-hidden';
/* On form cancel */
function onCancel() {
  let paths = window.location.pathname.split('/').filter((path) => path);
  let backURL = window.location.origin + '/' + paths[0] + '/' + paths[1];

  /* If it has opened on a new page, needs to go back with page reload otherwise without */
  if ($('.qor-slideout').hasClass('is-slided')) {
    window.history.pushState({}, null, backURL);
  } else {
    window.location.href = backURL;
  }
}

function CodeReferenceOnChange(inputId, value, crType) {
  const codeRefContainer = document.getElementById(`${inputId}_container`);
  codeRefContainer.style.display = 'flex';
  const codeRefEl = document.getElementById(inputId);
  let crValue;
  switch (crType) {
    case 'content':
      crValue = `safe .blocks.${value}.Content`;
      break;
    case 'image':
      crValue = `.blocks.${value}.Image.URL`;
      break;
    default:
      crValue = `.blocks.${value}.Content`;
      break;
  }
  codeRefEl.value = value == '' ? '' : `{{ ${crValue} }}`;
}

function copyToClipboard(elemId) {
  const codeRefEl = document.getElementById(elemId);
  navigator.clipboard.writeText(codeRefEl.value);
}

function hideHelpSection() {
  let overviewToggleButton = document.querySelector('.toggle-help-section');
  let overviewToggleSection = document.querySelector('.help-section');

  overviewToggleButton.style.display = 'none';
  overviewToggleSection.style.display = 'none';
  localStorage.setItem('hideHelpSection', 'hidden');
}

document.addEventListener(
  'DOMContentLoaded',
  function () {
    let overviewToggleButton = document.querySelector('.toggle-help-section');
    let overviewToggleSection = document.querySelector('.help-section');

    if (localStorage.getItem('hideHelpSection') === 'hidden' && overviewToggleButton) {
      overviewToggleButton.style.display = 'none';
      overviewToggleSection.style.display = 'none';
    }
  },
  false
);

function revealValue(elemId, emelValueId) {
  const codeRefEl = document.getElementById(elemId);
  const codeRefElValue = document.getElementById(emelValueId);
  console.log(elemId);
  console.log(emelValueId);
  if (codeRefEl.value === codeRefElValue.value) codeRefEl.value = '******';
  else codeRefEl.value = codeRefElValue.value;
}

function actionButtonToggleModal(id) {
  var modal = document.getElementById(id);
  if (modal.classList.contains('hidden')) {
    modal.classList.remove('hidden');
    modal.classList.add('shown');
    $(document).find('body').addClass(CLASS_OPEN);
    $(modal).attr(ARIA_HIDDEN, false);
  } else {
    modal.classList.add('hidden');
    modal.classList.remove('shown');
    $(document).find('body').removeClass(CLASS_OPEN);
    $(modal).attr(ARIA_HIDDEN, true);
  }
}

function actionButtonExecute(reloadPage, actionbuttonModalId, url, method, data, datatype) {
  $.ajax(url, {
    xhrFields: {
      withCredentials: true,
    },
    method,
    data,
    dataType: datatype || 'json',
    beforeSend: function (xhr) {
      console.log('beforeSend');
    },
    success: function (data) {
      console.log('success.data:', data);
    },
    error: function (err) {
      if (err.status == 200) {
        return;
      }
    },
    complete: function (response) {
      if (reloadPage) {
        window.location.reload();
      }
    },
  });
}
